package benefactorkindboxvalidator

import (
	"errors"

	param "git.gocasts.ir/ebhomengo/niki/param/benefactor/kind_box"
	errmsg "git.gocasts.ir/ebhomengo/niki/pkg/err_msg"
	richerror "git.gocasts.ir/ebhomengo/niki/pkg/rich_error"
	validation "github.com/go-ozzo/ozzo-validation/v4"
)

func (v Validator) ValidateGetAll(req param.KindBoxGetAllRequest) (map[string]string, error) {
	const op = "benefactorkindboxvalidator.ValidateGetAll"

	validFields := []string{
		"id", "kind_box_req_id", "kind_box_type", "amount", "serial_number",
		"status", "deliver_refer_time_id", "deliver_refer_date", "deliver_address_id", "sender_agent_id",
		"delivered_at", "return_refer_time_id", "return_refer_date",
		"return_address_id", "receiver_agent_id", "returned_at",
	}
	if err := validation.ValidateStruct(&req,
		validation.Field(&req.Filter, validation.By(v.areFilterFieldsValid(validFields))),
		validation.Field(&req.Sort, validation.By(v.areSortFieldsValid(validFields))),
	); err != nil {

		fieldErrors := make(map[string]string)

		var errV validation.Errors
		if errors.As(err, &errV) {
			for key, value := range errV {
				if value != nil {
					fieldErrors[key] = value.Error()
				}
			}
		}

		return fieldErrors, richerror.New(op).
			WithMessage(errmsg.ErrorMsgInvalidInput).
			WithKind(richerror.KindInvalid).
			WithMeta(map[string]interface{}{"req": req}).
			WithErr(err)
	}

	// nolint
	return nil, nil
}
